#include <iostream>
#include <string>

class Person {
	std::string name;
	int age;

public:
	Person(const std::string& name, int age)
	    : name(name)
	    , age(age) {
		std::cout << "New Person created: " << name << '\n';
	}

	void sayHello() {
		std::cout << name << " (age " << age << ") says Hello!\n";
	}

	void rename(const std::string& newName) {
		name = newName;
	}

	const std::string& getName() const {
		return name;
	}

	int getSalary();
};

int Person::getSalary() {
	return 1000000;
}

int main() {
	Person rick{ "Rick Sanchez", 70 };
	Person& ref = rick;

	Person morty = { "Morty Smith", 14 };

	ref = morty;

	rick.sayHello();

	std::cout << Person("Jerry Smith", 34).getName() << '\n';
}
