#include <iostream>

class MyObject {
	int x, y;

public:
	MyObject(int x, int y) : x(x), y(y) {}
	int getX() const { return x; };
	int getY() const { return y; };
	void setX(int nx) { x = nx; }
	void setY(int ny) { y = ny; }
};

// this simulates the call-by-sharing semantics (Java, Python etc.)
void f(MyObject* a) {
	MyObject local(10, 12);

	MyObject* b = &local;
	a->setX(100);
	a = b;
	a->setY(50);
	b->setX(20);
}

int main() {
	MyObject o(0, 0);
	f(&o);
	std::cout << o.getX() + o.getY() << '\n';
}
